<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select
          v-model:value="model[field]"
          placeholder="请选择行业分类"
          :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions"
          @change="changeSuspect"
        ></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select
          v-model:value="model[field]"
          show-search
          placeholder="请选择二级"
          allow-clear
          tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }"
          :tree-data="treeData"
          tree-node-filter-prop="label"
        >
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleView" v-auth="'fxpg-dsl-jbxx'">查看基本信息</a-button>
        <a-button type="primary" @click="handleAdd('ysl')" v-auth="'fxpg-dsl-ysl'">预受理</a-button>
        <a-button type="primary" @click="handleAdd('')" v-auth="'fxpg-dsl-sl'">受理</a-button>
        <a-button type="primary" @click="onExportXls" v-auth="'fxpg-dsl-dc'">导出</a-button>
        <a-button type="primary" @click="handelStep" v-auth="'fxpg-dsl-lct'">流程图</a-button>
      </template>
    </BasicTable>
    <AcceptanceModal @register="registerModal" @success="handleSuccess" />
    <!-- 预受理 -->
    <Paccept @register="registerlyslModal" @success="handleSuccess" />
    <!-- 流程图 -->
    <Step @register="registerlcModal" />
  </div>
</template>

<script lang="ts" name="dkgl-fxpg-Acceptance" setup>
  import { useRouter } from 'vue-router';
  import { BasicTable } from '/@/components/Table';
  import { useModal } from '/@/components/Modal';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
  import { acceptanceList, getImportUrl, getExportUrl } from './api';
  import AcceptanceModal from '@/components/customComponent/AcceptanceModal.vue';
  import Paccept from '@/components/customComponent/Pacceptance.vue';
  import Step from '/@/components/customComponent/steps/step.vue';
  import { chTip } from '@/utils/checkTip';

  const router = useRouter();
  const { createMessage } = useMessage();
  //注册model
  const [registerModal, { openModal }] = useModal();
  const [registerlcModal, { openModal: openlcModal }] = useModal();
  const [registerlyslModal, { openModal: openlyslModal }] = useModal();
  //注册table数据
  const { tableContext, onExportXls } = useListPage({
    tableProps: {
      title: '风险评估-待受理',
      api: acceptanceList,
      columns,
      canResize: false,
      clickToRowSelect: true,
      showActionColumn: false,
      //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
      rowKey: 'wrdkid',
      rowSelection: { type: 'radio' },
      beforeFetch() {
        let res = [...columns];
        res.splice(7, 0, {
          title: '完成初审提醒',
          dataIndex: 'tx',
          resizable: true,
        });

        setColumns(res);
      },
      formConfig: {
        labelWidth: 120,
        schemas: [
          ...searchFormSchema,
          {
            label: '阶段内状态',
            field: 'jdnzt',
            component: 'Input',
            defaultValue: 'DSL',
            show: false,
          },
        ],
        autoSubmitOnEnter: true,
        showAdvancedButton: false,
      },
    },
    exportConfig: {
      name: '风险评估-待受理',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
    },
  });
  const isSuspectOptions = useSuspectsData().data; // 行业分类
  const useCategory = useCategoryData();
  const treeData = useCategory.data; // 行业类别-数据
  const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
  const [registerTable, { reload, setColumns }, { rowSelection, selectedRowKeys, selectedRows }] = tableContext;
  // 查看基本信息
  function handleView() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    router.push(`/dkgl/fxpg/ViewDetail?wrdkid=${selectedRowKeys.value[0]}`);
  }
  /**
   * 受理
   */
  function handleAdd(v) {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    if (!chTip(selectedRows.value)) return;
    if (v == 'ysl') {
      openlyslModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
      });
    } else {
      // 判断有没有预售时间
      if (!selectedRows.value[0].tx) {
        createMessage.info('请先进行预处理');
        return;
      }
      openModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
      });
    }
  }
  // 点击查看流程图
  function handelStep() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    openlcModal(true, {
      record: selectedRows.value[0],
      isUpdate: true,
      showFooter: true,
    });
  }
  function handleSuccess() {
    reload();
    rowSelection.value = [];
    selectedRowKeys.value = [];
  }
</script>
<style scoped></style>
